/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.gui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.*;
import javax.swing.table.DefaultTableModel;
import org.visnow.vn.lib.utils.numeric.minimization.ConjugateGradientsParameters;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class CGMinimizationControlPanel extends javax.swing.JPanel
{

    ConjugateGradientsParameters[] params = null;

    /**
     * Creates new form CGMinimizationControlPanel
     */
    public CGMinimizationControlPanel()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        GridBagConstraints gridBagConstraints;

        runToggle = new JToggleButton();
        breakToggle = new JToggleButton();
        levelInfoLabel = new JLabel();
        levelResultsLabel = new JLabel();
        jTabbedPane1 = new JTabbedPane();
        jScrollPane2 = new JScrollPane();
        minimizationLogTable = new JTable();
        jScrollPane3 = new JScrollPane();
        jPanel1 = new JPanel();
        jLabel1 = new JLabel();
        jLabel4 = new JLabel();
        jLabel5 = new JLabel();
        jLabel6 = new JLabel();
        graphPanel = new JPanel();
        jScrollPane1 = new JScrollPane();
        minimizationProtocolTable = new JTable();

        setMinimumSize(new Dimension(350, 252));
        setOpaque(false);
        setPreferredSize(new Dimension(400, 500));
        setLayout(new GridBagLayout());

        ResourceBundle bundle = ResourceBundle.getBundle("org/visnow/vn/lib/gui/Bundle"); // NOI18N
        runToggle.setText(bundle.getString("GUI.runToggle.text")); // NOI18N
        runToggle.setMinimumSize(new Dimension(82, 25));
        runToggle.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                runToggleActionPerformed(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new Insets(5, 0, 5, 0);
        add(runToggle, gridBagConstraints);

        breakToggle.setText(bundle.getString("GUI.breakToggle.text")); // NOI18N
        breakToggle.setMaximumSize(new Dimension(142, 25));
        breakToggle.setMinimumSize(new Dimension(82, 25));
        breakToggle.setPreferredSize(new Dimension(142, 25));
        breakToggle.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                breakToggleActionPerformed(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(breakToggle, gridBagConstraints);

        levelInfoLabel.setFont(new Font("Dialog", 0, 12));
        levelInfoLabel.setText(bundle.getString("GUI.levelInfoLabel.text")); // NOI18N
        levelInfoLabel.setVerticalAlignment(SwingConstants.TOP);
        levelInfoLabel.setMaximumSize(new Dimension(300, 100));
        levelInfoLabel.setMinimumSize(new Dimension(82, 100));
        levelInfoLabel.setPreferredSize(new Dimension(220, 100));
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new Insets(3, 2, 9, 0);
        add(levelInfoLabel, gridBagConstraints);

        levelResultsLabel.setFont(new Font("Dialog", 0, 12));
        levelResultsLabel.setText(bundle.getString("GUI.levelResultsLabel.text")); // NOI18N
        levelResultsLabel.setVerticalAlignment(SwingConstants.TOP);
        levelResultsLabel.setMaximumSize(new Dimension(300, 125));
        levelResultsLabel.setMinimumSize(new Dimension(82, 105));
        levelResultsLabel.setPreferredSize(new Dimension(200, 15));
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new Insets(3, 4, 9, 0);
        add(levelResultsLabel, gridBagConstraints);

        jScrollPane2.setMinimumSize(new Dimension(170, 150));
        jScrollPane2.setPreferredSize(new Dimension(180, 200));
        jScrollPane2.setRequestFocusEnabled(false);

        minimizationLogTable.setModel(new DefaultTableModel(
                new Object[][] {

                },
                new String[] {
                        "step", "value", "avg |∇|", "avg δ", "max δ", "extr", "bk", "in"
                }
                ) {
                    Class[] types = new Class[] {
                            Integer.class, Float.class, Float.class, Double.class, Double.class, Integer.class, Integer.class, Integer.class
                    };
                    boolean[] canEdit = new boolean[] {
                            false, false, false, false, false, false, false, false
                    };

                    public Class getColumnClass(int columnIndex) {
                        return types[columnIndex];
                    }

                    public boolean isCellEditable(int rowIndex, int columnIndex) {
                        return canEdit[columnIndex];
                    }
                });
        minimizationLogTable.setMinimumSize(new Dimension(240, 800));
        minimizationLogTable.setOpaque(false);
        minimizationLogTable.setPreferredSize(new Dimension(440, 2000));
        minimizationLogTable.getTableHeader().setReorderingAllowed(false);
        jScrollPane2.setViewportView(minimizationLogTable);

        jTabbedPane1.addTab("log", jScrollPane2);

        jPanel1.setMinimumSize(new Dimension(200, 1000));
        jPanel1.setPreferredSize(new Dimension(300, 1000));
        jPanel1.setLayout(new GridBagLayout());

        jLabel1.setForeground(new Color(102, 102, 102));
        jLabel1.setText(bundle.getString("GUI.jLabel1.text")); // NOI18N
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jLabel1, gridBagConstraints);

        jLabel4.setForeground(new Color(153, 0, 0));
        jLabel4.setText(bundle.getString("GUI.jLabel4.text")); // NOI18N
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jLabel4, gridBagConstraints);

        jLabel5.setForeground(new Color(0, 153, 0));
        jLabel5.setText(bundle.getString("GUI.jLabel5.text")); // NOI18N
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jLabel5, gridBagConstraints);

        jLabel6.setForeground(new Color(0, 0, 153));
        jLabel6.setText(bundle.getString("GUI.jLabel6.text")); // NOI18N
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jLabel6, gridBagConstraints);

        graphPanel.setMinimumSize(new Dimension(300, 2000));
        graphPanel.setPreferredSize(new Dimension(300, 2000));
        graphPanel.setLayout(new BorderLayout());
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(graphPanel, gridBagConstraints);

        jScrollPane3.setViewportView(jPanel1);

        jTabbedPane1.addTab("graph", jScrollPane3);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(jTabbedPane1, gridBagConstraints);

        jScrollPane1.setMinimumSize(new Dimension(180, 80));
        jScrollPane1.setPreferredSize(new Dimension(216, 100));

        minimizationProtocolTable.setModel(new DefaultTableModel(
                new Object[][] {
                        { new Integer(0), new Integer(75), new Integer(0), new Integer(0), new Float(0.1), new Float(0.25) },
                        { new Integer(1), new Integer(20), new Integer(280), new Integer(0), new Float(0.1), new Float(0.15) },
                        { new Integer(2), new Integer(50), new Integer(350), new Integer(0), new Float(0.1), new Float(0.1) }
                },
                new String[] {
                        "lv", "1", "2", "3", "avg|∇|", "max δ"
                }
                ) {
                    Class[] types = new Class[] {
                            Integer.class, Integer.class, Integer.class, Integer.class, Float.class, Float.class
                    };
                    boolean[] canEdit = new boolean[] {
                            false, true, true, true, true, true
                    };

                    public Class getColumnClass(int columnIndex) {
                        return types[columnIndex];
                    }

                    public boolean isCellEditable(int rowIndex, int columnIndex) {
                        return canEdit[columnIndex];
                    }
                });
        minimizationProtocolTable.setAutoscrolls(false);
        minimizationProtocolTable.setMaximumSize(new Dimension(2147483647, 300));
        minimizationProtocolTable.setMinimumSize(new Dimension(300, 300));
        minimizationProtocolTable.setPreferredSize(new Dimension(300, 300));
        jScrollPane1.setViewportView(minimizationProtocolTable);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        add(jScrollPane1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void runToggleActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_runToggleActionPerformed
    {//GEN-HEADEREND:event_runToggleActionPerformed
        if (params == null || params.length != minimizationProtocolTable.getRowCount())
            return;
        int[] restartSchedule = new int[3];
        for (int i = 0; i < minimizationProtocolTable.getRowCount(); i++) {
            for (int j = 0; j < 3; j++)
                try {
                    restartSchedule[j] = (Integer) minimizationProtocolTable.getValueAt(i, j + 6);
                } catch (Exception e) {
                }
            params[i].setRestartSchedule(restartSchedule);
        }
        for (int i = 0; i < minimizationProtocolTable.getRowCount(); i++)
            try {
                params[i].setGradientEpsToExit((Float) minimizationProtocolTable.getValueAt(i, 9));
            } catch (Exception e) {
            }
        for (int i = 0; i < minimizationProtocolTable.getRowCount(); i++)
            try {
                params[i].setMaxCoordMoveToExit((Float) minimizationProtocolTable.getValueAt(i, 10));
            } catch (Exception e) {
            }

    }//GEN-LAST:event_runToggleActionPerformed

    private void breakToggleActionPerformed(ActionEvent evt)//GEN-FIRST:event_breakToggleActionPerformed
    {//GEN-HEADEREND:event_breakToggleActionPerformed
        if (params == null)
            return;
    }//GEN-LAST:event_breakToggleActionPerformed

    public void setParams(ConjugateGradientsParameters[] params)
    {
        this.params = params;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private JToggleButton breakToggle;
    private JPanel graphPanel;
    private JLabel jLabel1;
    private JLabel jLabel4;
    private JLabel jLabel5;
    private JLabel jLabel6;
    private JPanel jPanel1;
    private JScrollPane jScrollPane1;
    private JScrollPane jScrollPane2;
    private JScrollPane jScrollPane3;
    private JTabbedPane jTabbedPane1;
    private JLabel levelInfoLabel;
    private JLabel levelResultsLabel;
    private JTable minimizationLogTable;
    private JTable minimizationProtocolTable;
    private JToggleButton runToggle;
    // End of variables declaration//GEN-END:variables
}
